local _, Class = UnitClass("Player");
local PlayerName = GetUnitName("Player", false);

PowerBars = {};
PowerBars.Buttons = {};
PowerBars.Check = {};
PowerBars.Dialogs = {};
PowerBars.Sliders = {};
PowerBars.Edits = {};
PowerBars.DropMenus = {};
PowerBars.DropMenus[Class] = {};
PowerBars.CurrFrame = {};
PowerBars.Base = {};
PowerBars.MsgLog = {};
PowerBars.MsgLog.Lines = {};
PowerBars.MsgLog.Text = "";
PowerBars.noCast = 0;
PowerBars.isUnlocked = false;

local MsgLog = PowerBars.MsgLog;

-- ===========================================
-- Setting DEFAULTS for Classes and Frame Size
-- ===========================================
PowerBars.Defaults = {};
PowerBars.Defaults[Class] = {};
local Defaults = PowerBars.Defaults[Class];
Defaults.Settings = {};

-- Set Universal Size, Width and Point constants
Defaults.Settings[1] = {};
Defaults.Settings[1].WIDTH = 256;
Defaults.Settings[1].HEIGHT = 64;
Defaults.Settings[1].POINT = "BOTTOM";
Defaults.Settings[1].RELATIVEPOINT = "CENTER";
Defaults.Settings[1].X_OFS = 0;
Defaults.Settings[1].Y_OFS = 0;
Defaults.Settings[1].SCALE = 1;
Defaults.Settings[2] = {};
Defaults.Settings[2].WIDTH = 256;
Defaults.Settings[2].HEIGHT = 32;
Defaults.Settings[2].POINT = "TOP";
Defaults.Settings[2].RELATIVEPOINT = "CENTER";
Defaults.Settings[2].X_OFS = 0;
Defaults.Settings[2].Y_OFS = 0;
Defaults.Settings[2].SCALE = 1;

-- Individual Size, Width and Point by class as well as individual class setttings.
if Class == "DEATHKNIGHT" then
	Defaults.Settings[1].WIDTH = 80;
	Defaults.Settings[1].HEIGHT = 120;
	for i=1,7 do
		local j = #(Defaults.Settings)+1;
		Defaults.Settings[j] = {}
		Defaults.Settings[j].WIDTH = Defaults.Settings[1].WIDTH/2;
		Defaults.Settings[j].HEIGHT = Defaults.Settings[1].HEIGHT/3;
		Defaults.Settings[j].SCALE = 1;
		if i == 1 then
			Defaults.Settings[j].POINT = "TOPLEFT";
			Defaults.Settings[j].RELATIVEPOINT = "TOPLEFT";
		elseif i % 2 == 0 then
			Defaults.Settings[j].POINT = "LEFT";
			Defaults.Settings[j].RELATIVEPOINT = "RIGHT";
		else
			Defaults.Settings[j].POINT = "TOP";
			Defaults.Settings[j].RELATIVEPOINT = "BOTTOM";
		end
		Defaults.Settings[j].X_OFS = 0;
		Defaults.Settings[j].Y_OFS = 0;
	end
elseif Class == "WARLOCK" then
	Defaults.Settings[1].WIDTH = 192;
	Defaults.Settings[1].HEIGHT = 64;
	for i=1,3 do
		local j = #(Defaults.Settings)+1;
		Defaults.Settings[j] = {};
		Defaults.Settings[j].WIDTH = 64;
		Defaults.Settings[j].HEIGHT = 64;
		Defaults.Settings[j].X_OFS = 0;
		Defaults.Settings[j].Y_OFS = 0;
		Defaults.Settings[j].SCALE = 1;
		if i == 1 then
			Defaults.Settings[j].POINT = "TOPLEFT";
			Defaults.Settings[j].RELATIVEPOINT = "TOPLEFT";
		else
			Defaults.Settings[j].POINT = "LEFT";
			Defaults.Settings[j].RELATIVEPOINT = "RIGHT";
		end
	end
elseif Class == "PALADIN" then
	Defaults.Settings[1].WIDTH = 360;
	Defaults.Settings[1].HEIGHT = 60;
	for i=1,3 do
		local j = #(Defaults.Settings)+1;
		Defaults.Settings[j] = {};
		Defaults.Settings[j].WIDTH = 120;
		Defaults.Settings[j].HEIGHT = 60;
		Defaults.Settings[j].X_OFS = 0;
		Defaults.Settings[j].Y_OFS = 0;
		Defaults.Settings[j].SCALE = 1;
		if i == 1 then
			Defaults.Settings[j].POINT = "TOPLEFT";
			Defaults.Settings[j].RELATIVEPOINT = "TOPLEFT";
		else
			Defaults.Settings[j].POINT = "LEFT";
			Defaults.Settings[j].RELATIVEPOINT = "RIGHT";
		end
	end
	PowerBars.currHPW = 0;
	PowerBars.lastHPW = 0;
elseif Class == "DRUID" then
	-- Bar frame
	Defaults.Settings[3] = {};
	Defaults.Settings[3].WIDTH = Defaults.Settings[1].WIDTH*0.57;
	Defaults.Settings[3].HEIGHT = Defaults.Settings[1].HEIGHT*0.20;
	Defaults.Settings[3].SCALE = 1;
	Defaults.Settings[3].POINT = "CENTER";
	Defaults.Settings[3].RELATIVEPOINT = "CENTER";
	Defaults.Settings[3].X_OFS = (Defaults.Settings[1].WIDTH*0.05)*-1;
	Defaults.Settings[3].Y_OFS = (Defaults.Settings[1].HEIGHT*0.03)*-1;
	-- Arrow Frame
	Defaults.Settings[4] = {};
	Defaults.Settings[4].WIDTH = 32;
	Defaults.Settings[4].HEIGHT = 32;
	Defaults.Settings[4].SCALE = 1;
	Defaults.Settings[4].POINT = "CENTER";
	Defaults.Settings[4].RELATIVEPOINT = "CENTER";
	Defaults.Settings[4].X_OFS = 0;
	Defaults.Settings[4].Y_OFS = 0;
	-- Eclipse Text
	Defaults.Settings[5] = {};
	Defaults.Settings[5].WIDTH = Defaults.Settings[1].WIDTH*0.14;
	Defaults.Settings[5].HEIGHT = Defaults.Settings[1].HEIGHT*0.32;
	Defaults.Settings[5].SCALE = 1;
	Defaults.Settings[5].POINT = "CENTER";
	Defaults.Settings[5].RELATIVEPOINT = "CENTER";
	Defaults.Settings[5].X_OFS = (Defaults.Settings[1].WIDTH*0.03)*-1; 
	Defaults.Settings[5].Y_OFS = (Defaults.Settings[1].HEIGHT*0.02)*-1;
	-- vEclipse Text
	Defaults.Settings[6] = {};
	Defaults.Settings[6].WIDTH = Defaults.Settings[1].WIDTH*0.14;
	Defaults.Settings[6].HEIGHT = Defaults.Settings[1].HEIGHT*0.32;
	Defaults.Settings[6].SCALE = 1;
	Defaults.Settings[6].POINT = "TOP";
	Defaults.Settings[6].RELATIVEPOINT = "BOTTOM";
	Defaults.Settings[6].X_OFS = 0;
	Defaults.Settings[6].Y_OFS = 0;
	PowerBars.isRotated = 0;
	PowerBars.SpellTable = {};
	PowerBars.ShootingStars = {};
	PowerBars.ShootingStars.isActive = 0;
	PowerBars.WrathCount = 0;
	PowerBars.CastID = 0;
	PowerBars.TotalCasts = 0;
	PowerBars.ShootingStars.Timer = CreateFrame("FRAME");
	PowerBars.ShootingStars.Timer:SetScript("OnUpdate",
		function(self, elapsed)
			PowerBars.ShootingStars.ProcTime = PowerBars.ShootingStars.ProcTime - elapsed;
			if PowerBars.ShootingStars.ProcTime <= 0 then
				if PowerBars.ShootingStars.isActive == 1 then
					PowerBars.ShootingStars.isActive = 0;
					MsgLog:AddLine("Shooting Stars proc has expired.");
					self:Hide();
				end
			end
		end);
	PowerBars.ShootingStars.Timer:Hide();
elseif Class == "HUNTER" then
	-- nil
elseif Class == "ROGUE" then
	-- nil
elseif Class == "WARRIOR" then
	-- nil
elseif Class == "MAGE" then
	-- nil
elseif Class == "SHAMAN" then
	-- nil
elseif Class == "PRIEST" then
	-- nil
end

local eventHandler = CreateFrame("FRAME");
eventHandler:RegisterEvent("ADDON_LOADED");
eventHandler:RegisterEvent("PLAYER_ENTERING_WORLD");
eventHandler:RegisterEvent("PLAYER_ALIVE");
eventHandler:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
eventHandler:RegisterEvent("UPDATE_SHAPESHIFT_FORM");
eventHandler:RegisterEvent("UNIT_POWER");
eventHandler:RegisterEvent("RUNE_POWER_UPDATE");
eventHandler:RegisterEvent("RUNE_TYPE_UPDATE");
eventHandler:RegisterEvent("UNIT_AURA");
eventHandler:RegisterEvent("UNIT_SPELLCAST_START");
eventHandler:RegisterEvent("UNIT_SPELLCAST_SENT");
eventHandler:RegisterEvent("UNIT_SPELLCAST_STOP");
eventHandler:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
eventHandler:RegisterEvent("UNIT_SPELLCAST_FAILED");
eventHandler:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
eventHandler:RegisterEvent("PLAYER_REGEN_DISABLED");
eventHandler:RegisterEvent("PLAYER_REGEN_ENABLED");
eventHandler:SetScript("OnEvent",
	function(frame, event, ...)
		if event == "ADDON_LOADED" then
			local addon = ...;
			if addon == "PowerBars" then
				PowerBars:DoSavedVars();
				PowerBars:CallMsgConsole()
				PowerBars:GetInfo();
				PowerBars:InitFrames();
				PowerBars:ShowUnlock();
				PowerBars:ShowChangePower();
				PowerBars:CreateSlash();
			elseif addon == "OmniCC" or addon == "tullaCC" then
				if Class == "DEATHKNIGHT" then
					PowerBars.Check.OmniCC:Enable();
				end
			end
		elseif event == "PLAYER_ENTERING_WORLD" then
			PowerBars:GetInfo();
			PowerBars:SetPowerFrames();
			PowerBars:CheckBlizzResFrame();
			if Class == "DRUID" then
				PowerBars:SetDruidSettings();
			end
		elseif event == "PLAYER_ALIVE" then
			PowerBars:GetInfo();
			PowerBars:CheckBlizzResFrame();
			PowerBars:ShowChangePower();
			if Class == "DRUID" and GetPrimaryTalentTree() == 1 and not PowerBars.Eclipse then
				PowerBars:SetEclipseFrames();
			else
				if Class == "DRUID" and GetPrimaryTalentTree() ~= 1 then
					PowerBars:SetDruidSettings();
				end
			end
		elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
			if Class == "DRUID" then
				PowerBars:SetDruidSettings();
			end
		elseif event == "UPDATE_SHAPESHIFT_FORM" then
			if Class == "DRUID" then
				if GetPrimaryTalentTree() == 1 then
					local currForm = GetShapeshiftFormID();
					if not currForm or currForm == 31 then
						PowerBars:AdjustFormAlpha(1)
					else
						PowerBars:AdjustFormAlpha(0)
					end
				end
				PowerBars:IfShapeshift("DRUID");
				PowerBars:SetPowerFrames();
			end
		elseif event == "UNIT_POWER" or event == "RUNE_TYPE_UPDATE" or event == "RUNE_POWER_UPDATE" or  event == "UNIT_AURA" then
			local args = {};
			if Class == "PALADIN" then
				local Unit;
				Unit, args[1] = ...;
			end
    		PowerBars:ShowChangePower(event, args);
    		if event == "UNIT_AURA" and Class == "DRUID" and GetPrimaryTalentTree() == 1 then
    			if UnitBuff("Player", GetSpellInfo(93400)) then
    				MsgLog:AddLine("Shooting Stars proc!");
    				PowerBars.ShootingStars.isActive = 1;
    				PowerBars.ShootingStars.ProcTime = 8;
    				PowerBars.ShootingStars.Timer:Show();
    			end
    		end
		elseif event == "UNIT_SPELLCAST_START" or event == "UNIT_SPELLCAST_STOP" or event == "UNIT_SPELLCAST_SUCCEEDED" or event == "UNIT_SPELLCAST_FAILED" or event == "UNIT_SPELLCAST_SENT" then
			if Class == "DRUID" and GetPrimaryTalentTree() == 1 then
				local unit = ...;
				if unit == "player" then
					local _, spell = ...
					PowerBars:ModifyCast(event, spell);
				end
			end
		elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
			if Class == "DRUID" and GetPrimaryTalentTree() == 1 then
				local _, _, subEvent, _, playerName = ...;
				if playerName == PlayerName then
					--print(...);
					if subEvent == "SPELL_DAMAGE" or subEvent == "SPELL_ENERGIZE" or subEvent == "SPELL_MISSED" then
						if subEvent == "SPELL_DAMAGE" then
							local _, _, _, _, _, _, _, _, _, spellID, spellName = ...;
							PowerBars:RemoveSpell(subEvent, spellID, spellName);
						elseif subEvent == "SPELL_ENERGIZE" then
							local _, _, _, _, _, _, _, _, _, _, _, energyAmount = ...;
							PowerBars:RemoveSpell(subEvent, energyAmount);
						elseif subEvent == "SPELL_MISSED" then
							local _, _, _, _, _, _, _, _, spellID, spellName, _, spellMiss = ...;
							PowerBars:RemoveSpell(subEvent, spellID, spellName, spellMiss);
						end
					end
				end
			end
		elseif event == "PLAYER_REGEN_DISABLED" then
			PowerBars:AdjustOOCAlpha(1);
		elseif event == "PLAYER_REGEN_ENABLED" then
			PowerBars:AdjustOOCAlpha(0);
		end
	end);

local function SetSavedFrames()
	local j = #(PowerBarsDB.PowSet.Frame)+1;
	PowerBarsDB.PowSet.Frame[j] = {};
	local Frame = PowerBarsDB.PowSet.Frame[j];
	local Defaults = PowerBars.Defaults[Class];
	Frame.Width = Defaults.Settings[j].WIDTH;
	Frame.Height = Defaults.Settings[j].HEIGHT;
	Frame.Point = Defaults.Settings[j].POINT;
	Frame.RelativePoint = Defaults.Settings[j].RELATIVEPOINT;
	Frame.X_Ofs = Defaults.Settings[j].X_OFS;
	Frame.Y_Ofs = Defaults.Settings[j].Y_OFS;
	Frame.Scale = PowerBarsDB.PowSet.Frame[1].Scale;
	Frame.isMoved = 0;
	Frame.isScaled = 0;
end

function PowerBars:DoSavedVars()
	local DEFS = PowerBars.Defaults[Class].Settings;
        if not PowerBarsDB then
        	PowerBarsDB = {}
        end
        if not PowerBarsDB.PowSet then
            PowerBarsDB.PowSet = {}
        end
        if not PowerBarsDB.PowSet.PowIMG then
            PowerBarsDB.PowSet.PowIMG = "";
        end
        if not PowerBarsDB.PowSet.ResBase then
            PowerBarsDB.PowSet.ResBase = 1;
        end
        if not PowerBarsDB.PowSet.DefaultIMG then
            PowerBarsDB.PowSet.DefaultIMG = 1;
        end
        -- Remove later v
        if PowerBarsDB.PowSet.DefaultIMG == true then
        	PowerBarsDB.PowSet.DefaultIMG = 1;
        end
        if not PowerBarsDB.PowSet.SavedResIMG then
        	PowerBarsDB.PowSet.SavedResIMG = "Custom";
        end
        if not PowerBarsDB.PowSet.SavedPowIMG then
        	PowerBarsDB.PowSet.SavedPowIMG = "Custom";
        end
        if not PowerBarsDB.PowSet.ResAlpha then
        	PowerBarsDB.PowSet.ResAlpha = 1;
        end
        if not PowerBarsDB.PowSet.PowAlpha then
        	PowerBarsDB.PowSet.PowAlpha = 1;
        end
        if not PowerBarsDB.PowSet.ResOOCAlpha then
        	PowerBarsDB.PowSet.ResOOCAlpha = 1;
        end
        if not PowerBarsDB.PowSet.PowOOCAlpha then
        	PowerBarsDB.PowSet.PowOOCAlpha = 1;
        end
        if not PowerBarsDB.PowSet.Frame then
            PowerBarsDB.PowSet.Frame = {}
        end
        if not PowerBarsDB.PowSet.Frame[1] then
            PowerBarsDB.PowSet.Frame[1] = {};
        end
        if not PowerBarsDB.PowSet.Frame[2] then
        	PowerBarsDB.PowSet.Frame[2] = {};
        end
        if not PowerBarsDB.PowSet.Frame[1].Scale then
        	PowerBarsDB.PowSet.Frame[1].Scale = DEFS[1].SCALE;
        end
        if not PowerBarsDB.PowSet.Frame[2].Scale then
        	PowerBarsDB.PowSet.Frame[2].Scale = DEFS[2].SCALE;
        end
        if not PowerBarsDB.PowSet.Frame[1].Width then
        	PowerBarsDB.PowSet.Frame[1].Width = DEFS[1].WIDTH;
        end
        if not PowerBarsDB.PowSet.Frame[2].Width then
        	PowerBarsDB.PowSet.Frame[2].Width = DEFS[2].WIDTH;
        end
        if not PowerBarsDB.PowSet.Frame[1].Height then
        	PowerBarsDB.PowSet.Frame[1].Height = DEFS[1].HEIGHT;
        end
        if not PowerBarsDB.PowSet.Frame[2].Height then
        	PowerBarsDB.PowSet.Frame[2].Height = DEFS[2].HEIGHT;
        end
        if not PowerBarsDB.PowSet.Frame[1].Point then
            PowerBarsDB.PowSet.Frame[1].Point = DEFS[1].POINT;
        end
        if not PowerBarsDB.PowSet.Frame[2].Point then
        	PowerBarsDB.PowSet.Frame[2].Point = DEFS[2].POINT;
        end
        if not PowerBarsDB.PowSet.Frame[1].RelativePoint then
            PowerBarsDB.PowSet.Frame[1].RelativePoint = DEFS[1].RELATIVEPOINT;
        end
        if not PowerBarsDB.PowSet.Frame[2].RelativePoint then
        	PowerBarsDB.PowSet.Frame[2].RelativePoint = DEFS[2].RELATIVEPOINT;
        end
        if not PowerBarsDB.PowSet.Frame[1].X_Ofs then
            PowerBarsDB.PowSet.Frame[1].X_Ofs = DEFS[1].X_OFS;
        end
        if not PowerBarsDB.PowSet.Frame[2].X_Ofs then
        	PowerBarsDB.PowSet.Frame[2].X_Ofs = DEFS[2].X_OFS;
        end
        if not PowerBarsDB.PowSet.Frame[1].Y_Ofs then
            PowerBarsDB.PowSet.Frame[1].Y_Ofs = DEFS[1].Y_OFS;
        end
        if not PowerBarsDB.PowSet.Frame[2].Y_Ofs then
        	PowerBarsDB.PowSet.Frame[2].Y_Ofs = DEFS[2].Y_OFS;
        end
         if not PowerBarsDB.PowSet.Frame[1].isMoved then
        	PowerBarsDB.PowSet.Frame[1].isMoved = 0;
        end
        if not PowerBarsDB.PowSet.Frame[2].isMoved then
        	PowerBarsDB.PowSet.Frame[2].isMoved = 0;
        end
        if not PowerBarsDB.Options then
            PowerBarsDB.Options = {};
        end
        if not PowerBarsDB.Options.ErrorConsole then
        	PowerBarsDB.Options.ErrorConsole = 0;
        end
        if not PowerBarsDB.Options.IsMove then
            PowerBarsDB.Options.IsMove = false;
        end
        if not PowerBarsDB.Options.IsResize then
            PowerBarsDB.Options.IsResize = false;
        end
        if not PowerBarsDB.PowSet.EclipseBarFont then
        	PowerBarsDB.EclipseBarFont = 14;
        end
        if not PowerBarsDB.PowSet.ResTexture then
        	PowerBarsDB.PowSet.ResTexture = 1;
        end
        if not PowerBarsDB.PowSet.PowDisable then
        	PowerBarsDB.PowSet.PowDisable = 0;
        end
        if not PowerBarsDB.PowSet.BlizzResDisable then
        	PowerBarsDB.PowSet.BlizzResDisable = 0;
        end
        if not PowerBarsDB.PowSet.BaseFrameAlpha then
        	PowerBarsDB.PowSet.BaseFrameAlpha = 0.5;
        end
        if not PowerBarsDB.PowSet.Unlocked then
        	PowerBarsDB.PowSet.Unlocked = 0;
        end
        if not PowerBarsDB.PowSet.NumBase then
        	PowerBarsDB.PowSet.NumBase = 3;
        end
        if not PowerBarsDB.PowSet.Aspect then
        	PowerBarsDB.PowSet.Aspect = {};
        	PowerBarsDB.PowSet.Aspect.Resource = 0;
        	PowerBarsDB.PowSet.Aspect.Power = 0;
        end
        if PowerBarsDB.PowSet.Frame[1] then
        	if PowerBarsDB.PowSet.Frame[3] then
        		if not PowerBarsDB.PowSet.Frame[3].isMoved then
        			for i=1,#(PowerBarsDB.PowSet.Frame) do
        				if not PowerBarsDB.PowSet.Frame[i].isMoved then
        					PowerBarsDB.PowSet.Frame[i].isMoved = 0;
        				end
        			end
        		end
        	end
        end
        if not PowerBarsDB.PowSet.Frame[1].isScaled then
        	for i=1,#(PowerBarsDB.PowSet.Frame) do
        		PowerBarsDB.PowSet.Frame[i].isScaled = 0;
        		if not PowerBarsDB.PowSet.Frame[i].isMoved then
        			PowerBarsDB.PowSet.Frame[i].isMoved = 0;
        		end
        	end
        end
        if not PowerBarsDB.Options[Class] then
        	PowerBarsDB.Options[Class] = {};
        end
        if PowerBarsDB.Options[Class] then
        	if Class == "DEATHKNIGHT" then
        		if not PowerBarsDB.Options.DEATHKNIGHT.Timers then
        			PowerBarsDB.Options.DEATHKNIGHT.Timers = 1;
        		end
        		if not PowerBarsDB.Options.DEATHKNIGHT.OmniCC then
        			PowerBarsDB.Options.DEATHKNIGHT.OmniCC = 0;
        		end
        		if not PowerBarsDB.PowSet.Frame[3] then
        			for i=1,7 do
						SetSavedFrames();
					end
        		end
        		if not PowerBarsDB.Options.DEATHKNIGHT.Layout then
        			PowerBarsDB.Options.DEATHKNIGHT.Layout = 1;
        		end
        		if not PowerBarsDB.Options.DEATHKNIGHT.ShowCD then
        			PowerBarsDB.Options.DEATHKNIGHT.ShowCD = 1;
        		end
        	elseif Class == "PALADIN" then
        		if not PowerBarsDB.PowSet.Frame[3] then
        			for i=1,3 do
						SetSavedFrames();
					end
				end
				if not PowerBarsDB.Options.PALADIN.Layout then
					PowerBarsDB.Options.PALADIN.Layout = 1;
				end
				if not PowerBarsDB.Options.PALADIN.NumHPW then
					PowerBarsDB.Options.PALADIN.NumHPW = 0;
				end
        	elseif Class == "WARLOCK" then
        		if not PowerBarsDB.PowSet.Frame[3] then
        			for i=1,3 do
						SetSavedFrames();
					end
				end
				if not PowerBarsDB.Options.WARLOCK.Layout then
					PowerBarsDB.Options.WARLOCK.Layout = 1;
				end
				if not PowerBarsDB.Options.WARLOCK.Soulburn then
					PowerBarsDB.Options.WARLOCK.Soulburn = 1;
				end
			elseif Class == "DRUID" then
				if not PowerBarsDB.PowSet.Frame[3] or not PowerBarsDB.PowSet.Frame[6] then
					for i=1,4 do
						SetSavedFrames();
					end            
				end
				if not PowerBarsDB.Options.DRUID.vTextShow then
					PowerBarsDB.Options.DRUID.vTextShow = 1;
				end
				if not PowerBarsDB.Options.DRUID.vWarnShow then
					PowerBarsDB.Options.DRUID.vWarnShow = 1;
				end
				if not PowerBarsDB.Options.DRUID.FormAlpha then
					PowerBarsDB.Options.DRUID.FormAlpha = 1;
				end
				if not PowerBarsDB.Options.DRUID.isVert then
					PowerBarsDB.Options.DRUID.isVert = 0;
				end
				if not PowerBarsDB.Options.DRUID.Unlocked then
					PowerBarsDB.Options.DRUID.Unlocked = 0;
				end
			end
        end
        
        -- Pre v0.3 Variables slated for removal...
        if PowerBarsDB.Options["Death Knight"] then
        	PowerBarsDB.Options.DEATHKNIGHT.Timers = PowerBarsDB.Options["Death Knight"].Timers;
        	PowerBarsDB.Options.DEATHKNIGHT.OmniCC = PowerBarsDB.Options["Death Knight"].OmniCC;
        	PowerBarsDB.Options["Death Knight"] = nil;
        end
        if PowerBarsDB.Options[UnitClass("Player")] then
        	PowerBarsDB.Options[UnitClass("Player")] = nil;
        end
        if PowerBarsDB.PowSet.ResDisable then
        	PowerBarsDB.PowSet.ResDisable = nil;
        end
        if PowerBarsDB.Options.PowDisable then
        	PowerBarsDB.Options.PowDisable = nil;
        end
end

function PowerBars:CreateSlash()
	SLASH_POWBAR1, SLASH_POWBAR2 = '/powbar', '/powb';
	local function PowBarSlash(msg, editbox)
		local command, phrase = msg:match("^(%S*)%s*(.-)$");
		if not command then
			command = "open";
		end
		local subcommand = {};
		local phraseLen = 0;
		local numSub = 0;
		if phrase and phrase ~= "" then
			--MsgLog:AddLine("Phrase: "..phrase);
			phraseLen = phrase:len();
			if phrase:find(" ") then
				local currPos = 1;
				local lastPos = 1;
				while currPos < phraseLen do
					if phrase:find(" ", currPos) then
						numSub = numSub + 1;
						currPos = phrase:find(" ", currPos);
						subcommand[numSub] = {}
						subcommand[numSub].startPos = lastPos;
						subcommand[numSub].endPos = (currPos-1)
						subcommand[numSub].String = phrase:sub(lastPos, (currPos-1)); 
						lastPos = currPos+1;
						currPos = currPos+1;
					else
						currPos = phraseLen;
						numSub = numSub + 1;
						subcommand[numSub] = {}
						subcommand[numSub].startPos = lastPos;
						subcommand[numSub].endPos = currPos;
						subcommand[numSub].String = phrase:sub(lastPos, currPos);
					end
					--MsgLog:AddLine("Sub "..numSub..": "..subCommand[numSub].String);
				end
			elseif phrase ~= "" then
					subcommand[1] = {};
					subcommand[1].startPos = 1;
					subcommand[1].endPos = phrase:len();
					subcommand[1].String = phrase;
					numSub = numSub + 1;
			end
		end
		if command:lower() == "" then
			MsgLog:AddLine("|cFFFFFF00/powb", "Slash Action")
			InterfaceOptionsFrame_OpenToCategory(PowerBars.panel.name);
		elseif command:lower() == "class" then
			MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 class", "Slash Action")
			InterfaceOptionsFrame_OpenToCategory(PowerBars.Class.name);
		elseif command:lower() == "resource" then
			MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 resource", "Slash Action")
			InterfaceOptionsFrame_OpenToCategory(PowerBars.Resource.name);
		elseif command:lower() == "power" then
			MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 power", "Slash Action")
			InterfaceOptionsFrame_OpenToCategory(PowerBars.Power.name);
		elseif command:lower() == "custom" then
			MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 custom", "Slash Action")
			InterfaceOptionsFrame_OpenToCategory(PowerBars.Custom.name);
		elseif command:lower() == "unlock" then
			MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 unlock", "Slash Action")
			PowerBars:doUnlock();
			PowerBars:ShowUnlock();
		elseif command:lower() == "config" or command:lower() == "open" then
			MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 config/open", "Slash Action")
			InterfaceOptionsFrame_OpenToCategory(PowerBars.panel.name);
		elseif command:lower() == "log" then
			if numSub > 0 then
				if subcommand[1].String:lower() == "spelltable" then
					local ST = PowerBars.SpellTable;
					local NumQueue = #ST;
					if NumQueue > 1 then
						MsgLog:AddLine("Spells Table has: "..NumQueue.." entries.");
						for i=1,NumQueue do
							MsgLog:AddLine("Spell: "..ST[i].Spell.." ("..ST[i].CastID..") ["..ST[i].Action.."]");
						end
					elseif NumQueue <= 0 then
						MsgLog:AddLine("|cFFFFFF00PowerBars:|cFFFFFFFF Spell table is empty, cannot display information.");
					else
						MsgLog:AddLine("Spells Table has: "..NumQueue.." entry.");
						MsgLog:AddLine("Spell: "..ST[1].Spell.." ("..ST[1].CastID..") ["..ST[1].Action.."]");
					end
				elseif tonumber(subcommand[1].String) then
					PowerBars:SetLines(tonumber(subcommand[1].String));
					PowerBars:CallMsgConsole();
				end
			else
				PowerBars:SetLines(#(MsgLog.Lines));
				PowerBars:CallMsgConsole();
			end
		elseif command:lower() == "msg" then
			if phraseLen > 0 then
				MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 msg:|cFFFFFFFF "..phrase, "Message");
			else
				print("|cFFFFFF00Power Bars:|cFFFFFFFF You need to type a message for it to appear in the Msg Log");
			end
		elseif command:lower() == "clear" then
			if numSub > 0 then
				if subcommand[1].String:lower() == "log" then
					local NumLines = #(PowerBars.MsgLog.Lines);
					for i=1,NumLines do
						PowerBars.MsgLog.Lines[i] = nil;
					end
					PowerBars.MsgLog.Text = "";
					for i=1,30 do
						MsgLog.Console.Frame.ScrollFrame.Lines[i]:SetText("");
					end
					PowerBars:SetLines(#(MsgLog.Lines));
					print("|cFFFFFF00Power Bars:|cFFFFFFFF message log cleared");
				elseif subcommand[1].String:lower() == "spelltable" then
					if Class == "DRUID" and GetPrimaryTalentTree() == 1 then
						local NumQueue = #PowerBars.SpellTable;
						if NumQueue > 1 then
							for i=1,NumQueue do
								PowerBars.SpellTable[i] = nil;
							end
						elseif NumQueue <= 0 then
							MsgLog:AddLine("|cFFFFFF00PowerBars:|cFFFFFFFF Spell table is empty, nothing to clear.");
						else
							PowerBars.SpellTable[1] = nil;
						end
						MsgLog:AddLine("|cFFFFFF00Power Bars:|cFFFFFFFF Spell Table: "..#PowerBars.SpellTable);
						print("|cFFFFFF00Power Bars:|cFFFFFFFF Spell Table: "..#PowerBars.SpellTable);
					else
						print("|cFFFFFF00Power Bars:|cFFFFFFFF Must be a Balance druid to use the Spell Table");
					end
				end
			else
				print("|cFFFFFF00Power Bars:|cFFFFFFFF command 'clear' takes the following subcommands:");
				print(":: log");
			end
		elseif command:lower() == "about" then
			MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 about", "Slash Action")
			print("|cFF00FF00----------------------------------------------------");
			print("|cFF00FF00Power Bars:|cFFFFFFFF A Resource & Power display AddOn");
			print("|cFF00FF00----------------------------------------------------");
			print("|cFF00FF00Author:|cFFFFFFFF Lulia (Steven Blea)");
			print("|cFFFFFF00Version:|cFFFFFFFF 0.52 |cFFFF0000(Beta)");
		elseif command:lower() == "help" then
			MsgLog:AddLine("|cFFFFFF00/powb|cFF00FF00 help", "Slash Action")
			print("|cFF00FF00----------------------------------------------------");
  			print("|cFF00FF00Power Bars:|cFFFFFFFF A Resource & Power display AddOn");
  			print("|cFF00FF00----------------------------------------------------");
  			print("|cFF00FF00/powbar|cFFFFFFFF - to access this menu.");
  			print("|cFF00FF00/powbar config|cFFFFFFFF - Opens up the main interface panel.");
  			print("|cFF00FF00/powbar <panel>|cFFFFFFFF - Opens up directly to the corresponding sub-panel.");
  			print("- |cFFFF0000ex: |cFF00FF00/powbar class|cFFFFFFFF - Opens up class-specific options.");
  			print("|cFF00FF00/powbar unlock|cFFFFFFFF - Opens up the move & resize dialog.");
  			print("|cFF00FF00/powbar about|cFFFFFFFF - Gives basic information about the AddOn");
  		end
	end
	SlashCmdList["POWBAR"] = PowBarSlash;
end